
(** valuation par nom et par valeur **)


(* tude d'un exemple *)

let sqr = fun x -> x*.x;;
let rec puiss' n x = 
   if n=0 then 1.
   else
   if (n mod 2)=0 then  sqr (puiss' (n/2) x)                 
       else x*.sqr(puiss' ((n-1)/2) x);;
puiss' 20000000 1.;;
let c = fun x -> 0;;
let rec f n = n*(f n);;
c f;;
c (f 5);;

(* Stratgie d'valuation de Caml *)

let mult x y = x*y;;
let triple = mult 3;;
let sqr x = x*x;;
let comp f g x = f (g x);;

(* Application  la rcursion *)

let rec fix F = F(fix F);;
let F = fun f n -> if n=0 then 1 else n * f (n-1);;
let fact = fix F;;
let rec fix F = F(fun n -> fix F n);;
let fact = fix F;;
fact 4;;

(** Dfinition par cas, filtrage **)


(* Avec fun *)

let neg = fun true -> false
             | false -> true;;
let xor = fun true true -> false
            | false true -> true
            | true false -> true
            | false false ->false;;
let xor = fun false x  -> x
             | true  x -> neg x ;;
let rec fact = fun 0 ->1
                   |n -> n*fact(n-1);;
let rec fib = fun 0 -> 1
                | 1 -> 1
                | n -> fib(n-1)+fib(n-2);;
fib 20;;
let f = fun  0 -> 1
           |  1 -> 1;;
f(0);;
f(1);;
f(3);;
let f = fun n -> 2*n
           | 0 -> 1;;
let xor= fun   true  true    -> false
             |  false false   -> false
             |   _     _      -> true   ;;
let xor= fun   true  true    -> false
             |  false false   -> false
             |     _      -> true;;
let xor = fun    (true, true) -> false
                 |(false,false)-> false
                 |     _       -> true  ;;
let xor  = function  (true, true)  -> false
                    | (false,false) -> false
                    |     _         -> true  ;;
let xor  = function   true  true  -> false
                     | false false -> false
                     |  _     _    -> true  ;;

(* Filtrage avec match ... with *)

match (5, 3) with  
       (_ ,0) -> 0
      |(x,y)  -> x/y;;

(** Polymorphisme **)

fst;;
snd;;
let id x = x;;
id (4,(id(5),id(true))) ;;
let comp f g x = f(g(x));;
let comp (f:bool->bool) (g:int->bool) = fun x -> f(g(x));;
let (comp : (bool -> bool) -> (int -> bool) -> int -> bool) =
fun f g x -> f(g(x));;
let 
   id = fun x->x 
 in 
   (id 1, id true);;

(** Les listes **)

failwith;;
failwith "essai";;
[1;2;3];;
[1];;
['a';'b';'c'];;
[];;
[1;'a'];;
fun x y -> x::y;;
6::[3;1];;
let hd = function []-> failwith "hd"
            | (a::l) -> a;;
hd [];;
hd [1;2;3];;
let tl = function []-> failwith "tl"
           | (a::l) -> l;;
tl [1;2;3];;
tl [1];;
tl [];;
let rec append l1 l2 =  
   match l1 with
      []   -> l2
   |  (x::xs ) -> (x::append xs l2) ;;
let (@@) = append;;
[1;2;3] @@ [4;5;6;7;8];;
[] @@ [1;2];;
[1;2] @@ [];;
(@);;
[1;2;3]@[4;5;6];;
let rec naive_rev = function      []    ->    []
                        |   (a::l)  -> naive_rev l @@ [a];;
naive_rev [1;2;3];;
naive_rev [];;
let rec revacc acc liste  = 
       match liste with
             []        -> acc
          |  (x::xs)   -> revacc (x::acc) xs ;;
revacc [1;2;3;4;5] [6;7;8;9];;
let rev = revacc [];;
rev [1;2;3;4;5;6];;
rev [];;
let rev liste = 
     let rec revacc acc liste = 
       match liste with
             []        -> acc
          |  (x::xs)   -> revacc (x::acc) xs 
     in
        revacc liste [] ;;
open List;;
fold_left;;
fold_right;;
let list_it = fold_left ;;
let it_list = fold_right ;;
let length = list_it (fun cpt a -> 1+ cpt) 0;;
let rev    = list_it (fun reverse a -> a:: reverse) [];;
let concat = it_list (fun  a l -> a::l);;
