let read_file fic =
  let
    ch = open_in fic;
  and
    refstr = ref "" 
  in
    try
      while true do
	refstr := !refstr^(input_line ch)
      done ;
	!refstr
    with
	End_of_file -> 
	  (close_in ch ); !refstr
;;
 
let affichier_resultat resultat theorie=
  begin
    print_endline "La thorie ";
    print_newline();
    Clause.theorie_print theorie; 
    print_newline();
    print_newline();
    match resultat with
	None ->
	  begin
	    print_endline "a t sature.";
	    print_endline "Elle est consistante :-)" 
	  end
      | Some(preuve) -> 
	  begin
	    print_endline "n'est pas consistante.";
	    print_endline "Voici une preuve de la clause vide :\n";
	    Preuve.print preuve;	    
	    print_newline()
	  end
  end;;

let read_theorie fic = Clause.theorie_of_string(read_file fic);;

let pretty_eval theorie =
  let
    resultat = Saturer.saturer theorie
  in
  affichier_resultat resultat theorie;;

