val lexer : 
  string -> 
  Genlex.token Stream.t
val parse_list :
  string ->
  (Genlex.token Stream.t -> 'a) ->
  Genlex.token Stream.t -> 'a list
val terme : 
  Genlex.token Stream.t -> 
  (string, string) Terme.t 
val at_formula :
  Genlex.token Stream.t -> 
  (string, string, string) Clause.atomic_formula 
val clause : 
  Genlex.token Stream.t -> 
  (string, string, string) Clause.clause 
val theorie :
  Genlex.token Stream.t -> 
  (string, string, string) Clause.clause list 

val terme_of_string :
  string -> 
  (string, string) Terme.t
val at_formula_of_string :
  string -> 
  (string, string, string) Clause.atomic_formula 
val clause_of_string : 
  string -> 
  (string, string, string) Clause.clause 
val theorie_of_string : 
  string -> 
  (string, string, string) Clause.clause list 
  
