type ('a,'b,'c) jclause 
type ('a,'b,'c) preuve = ('a,'b,'c) jclause list;;

(* Construction/deconstruction des objets *)
val of_theorie : 
  (string,string,string) Clause.theorie -> (string,string,string) preuve

val clause :
  ('a,'b,'c) jclause ->
  ('a,'b,'c) Clause.clause 

val to_string :
  (string,string,string)  preuve ->
  string

val print  :
  (string,string,string)  preuve ->
  unit

(** Le calcul R **)

val factoriser : 
  ('a,'b,'c) jclause * int * int ->
  ('a,'b,'c) jclause

val resolution :
  ('a,'b,'c) jclause * int  ->
  ('a,'b,'c) jclause * int ->
  ('a,'b,'c) jclause 

(* Autres operations *)

(* Il y a t'il une contradiction ? *)
val contradiction : ('a,'b,'c) preuve -> bool
val sous : ('a,'b,'c) jclause -> ('a,'b,'c) jclause -> bool

