let all_factorisations jcl  = 
  let (lg,ld) = Clause.length (Preuve.clause jcl) 
  and
    result = ref [] 
  in
    for i = 0 to ld - 2 do
      for j = i+1 to ld -1 do
	try
	  result := (Preuve.factoriser (jcl,i,j))::!result
	with
	    Failure "factoriser" -> ()
	  | Failure "nth" -> 
	      failwith "Mauvaise choix des indexes dans all_factorisations"
      done
    done;
    !result ;;

let all_resolutions jcl1 jcl2  = 
  let 
    (lg1,ld1) = Clause.length (Preuve.clause jcl1) 
  and
    (lg2,ld2) = Clause.length (Preuve.clause jcl2)
  and
    result = ref [] 
  in
    for i = 0 to ld1 -1 do
      for j = 0 to lg2 -1 do
	try
	  result := (Preuve.resolution (jcl1,i) (jcl2,j))::!result
	with
	    Failure "resolution" -> ()
	  | Failure "nth" -> 
	      failwith "Mauvaise choix des indexes dans all_resolutions"
      done
    done;
    for i = 0 to ld2 -1 do
      for j = 0 to lg1 -1 do
	try
	  result := (Preuve.resolution (jcl2,i) (jcl1,j))::!result
	with
	    Failure "resolution" -> ()
	  | Failure "nth" -> 
	      failwith "Mauvaise choix des indexes dans all_resolutions"
      done
    done;
    !result ;;
	
let faire_reagir clause liste = 
  (all_factorisations clause)@
  (List.concat (List.map (all_resolutions clause) liste));;
