(* Enlever Tautologies *)
let tautologies jclauses = 
  List.filter (fun jc  -> not (Clause.taut (Preuve.clause jc))) 
    jclauses;;

(* Enlever Super Clauses *)
(* Ce code sert de test *)
let filterless less listepivot liste =
  List.filter 
    (fun x -> not 
       (List.exists (fun pivot -> less pivot x) listepivot))
    liste;;

(* 
   Pour quelle raison cette definition donne des erreur de typage ?
   let susclauses  = filterless Clause.sous;;
*)

let susclauses listepivot liste =
  List.filter 
    (fun x -> not 
       (List.exists (fun pivot -> Preuve.sous pivot x) listepivot))
    liste;;

let simplifier wo us nouveaux  
  (* (wo : ('a, 'b, 'c) Clause.theorie ref) 
  (us :('a, 'b, 'c) Clause.theorie ref)
  (nouveaux :('a, 'b, 'c) Clause.theorie ref)
  *)
  = 
  nouveaux := tautologies !nouveaux;
  nouveaux := susclauses !wo !nouveaux;
  (* wo := susclauses !nouveaux !wo; *)
  us := susclauses !nouveaux !us;
  nouveaux := susclauses !us !nouveaux
;;

