type ('a,'b) t 
val faire_op : 'a -> ('a, 'b) t list -> ('a, 'b) t 
val faire_var : 'a -> ('b, 'a) t 

val to_string : (string, string) t -> string
val print : (string,string) t -> unit
val parse : Genlex.token Stream.t -> (string, string) t
val of_string : string -> (string,string) t

val vars : ('a, 'b) t -> 'b list 
type ('a, 'b) subst 
val identite : ('a, 'b) subst 
val faire_subst : 'a -> ('b, 'a) t -> ('b, 'a) subst
val subst_to_string : (string,string) subst -> string 
val print_subst  : (string,string) subst -> unit


val apply : ('a ,'b) subst -> ('a, 'b) t -> ('a, 'b) t 
val compose : ('a ,'b) subst -> ('a, 'b) subst -> ('a, 'b) subst
val filtrer : (('a, 'b) t * ('a, 'b) t) list -> ('a, 'b) subst 
val unify : (('a, 'b) t * ('a, 'b) t) list -> ('a, 'b) subst 
val merge_l :
  ('a,'b) subst list -> ('a,'b) subst list -> ('a,'b) subst list 
