(* Calcul du nieme nombre premier 
   Auteur: Anben PANGLOSE
   Cr le: 18 Octobre 2004
   Exercice 9 du TD 2 *)

(* indique si n est premier, en hypothse: n >= 2*)
let est_premier n =
  let rec _premier n i = 
    if n = 2 or i = 1 then 
      true
    else if n mod i = 0 then
      false
    else
      _premier n (i-1)
  in
  _premier n (n - 1)
;;

(* retourne le nieme nombre premier, en hypothse n >= 1 *)
let nieme_premier n = 
  let rec _nieme_premier nb_premier_restant candidat = 
    if nb_premier_restant = 0 then			(*on a trouve le nieme nombre premier*)
      candidat - 1
    else if est_premier candidat then	(*on comptabilise le nombre premier trouv *)
      _nieme_premier (nb_premier_restant-1) (candidat + 1)
    else
      _nieme_premier nb_premier_restant (candidat + 1)	(*le candidat n'est pas premier, au suivant! *)
  in
    _nieme_premier n 2
;;

nieme_premier 1000;;
