#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

int x = 0;

void interruption(int signum)
{
   switch(signum)
    {
    case SIGINT:
      printf("\nCTRL-C\n");
      x++;
      break;
    case SIGQUIT:
      printf("\nCTRL-\\\n");
      x--;
      break;
    default:
      printf("\nAutre signal\n");
      if(!x)
	signal(SIGINT,SIG_DFL);
    }
   printf("(x est maintenant gal  %d)\n", x); 
}

int main(void)
{
  signal(SIGINT,interruption);   /*  Recuperation de CRTL-C */
  signal(SIGQUIT,interruption);  /*  Recuperation de CRTL-\ */
  signal(SIGTSTP,interruption);  /*  Recuperation de CRTL-Z */ 
  
  for(;;)
    {
      printf("-");fflush(stdout);
      sleep(1);
    }
  return EXIT_SUCCESS;
}
