/* Exercice 4 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>

#define NB_FILS 10

void interruption(int signum)
{
}

void filio(void)
{
  int delai;

  srand(getpid()*time(NULL));
  delai = rand() % 10;
  printf("[%4d] J'ai choisi %d\n", getpid(),delai);
  pause();
  sleep(delai);
  exit(delai);
}

int main(void)
{
  int i,status;
  pid_t pid;
  struct sigaction action;

  /* Initialisation de l'handler */
  action.sa_handler=interruption;
  sigemptyset(&action.sa_mask);
  action.sa_flags=0;
  sigaction(SIGUSR1,&action,NULL);

  for(i=0;i< NB_FILS;i++)
        if(fork() == 0) filio();
  
  /* Que ce passe t-il si l'on enlve la ligne suivante ? */
  sleep(2); 
  /* Que ce passe t-il si  la place de la ligne suivante
     lon crive un cycle de la form
     for(i=0 ;i< NB_PROCESSUS;i++) kill(pid[i],...); ? */
  kill(0,SIGUSR1); 
  for(i=0;i< NB_FILS;i++)
    {
      pid = wait(&status);
      if(WIFEXITED(status)) 
	printf("[%4d] Le fils %d est arriv %d-ime\n", getpid(),pid,i+1);
    }
  
  exit(EXIT_SUCCESS);
}
