(* Lexeur *)
let lexer s =
  let ll = Genlex.make_lexer ["{";"}";";";"(";")";",";"=>"] 
  in  ll (Stream.of_string s) ;;

(* Parsing des listes *)
let parse_list sep parse_how =
  let rec 
    parse_l  = parser
	[< t = parse_how ; q = parse_rest >] -> t::q
      | [<>] -> []
  and
    parse_rest  stream = 
    if Stream.peek stream = Some(Genlex.Kwd sep) then
      match stream with
	  parser [<'Genlex.Kwd x ; q = parse_l >] -> q
    else  
      match stream with parser [<>] -> []
  in
    parse_l
;;

