let rec mapfilter fonction liste =
  let rec mapfilter accu = function
      [] -> List.rev accu
    | t :: q -> 
	let tl=
	  try 
	    [ fonction t ]
	  with
	      Failure(_)  -> []
	in
	  mapfilter (tl @ accu) q
  in
    mapfilter [] liste;;
 
let rec list_to_string sep to_string_how  =
  function
      [] -> ""
    | [t] -> to_string_how t
    | t::q -> (to_string_how t)^sep^
	(list_to_string sep to_string_how  q);;
