let saturer theorie =
  let wo = ref []
  and us = ref (Preuve.of_theorie theorie)
  in
  let 
    sature = ref false 
  and
    contradictoire = ref false
  in
    (*
       us := Simplifier.tautologies !us;
       us := Simplifier.susclauses !us !us;
    *)
    begin
      while not (!sature) && not (!contradictoire) do
	Gc.compact();
	if !us = [] then
	  sature := true
	else 
	  if Preuve.contradiction !us then 
	    contradictoire := true
	  else
	    let c = List.hd !us in
	      (*
		print_newline();
		print_endline "Traitement de : ";
		Clause.print c;
		print_newline() ;
	      *)
	      wo:= c::!wo;
	      us := List.tl !us;
	      let
		(* Produire *)
		nouveaux = ref (Produire.faire_reagir c !wo)  
	      in
		(* Simplfier *)
		Simplifier.simplifier wo us nouveaux; 
		us:= (!us)@(!nouveaux)
      done;
      match !contradictoire with
	  true -> Some((List.rev !wo)@(!us)) 
	| false -> None
    end;;
