#include <stdio.h>
#include <stdlib.h>

#define DIM_TAMPON 1024

int main(int argc, char *argv[])
{
  char tampon[DIM_TAMPON];
  FILE *fic1, *fic2;
 
  if(argc != 3)
    exit(EXIT_FAILURE);

  if( 
     (fic1 = fopen(argv[1],"r")) == NULL 
     || 
     (fic2 = fopen(argv[2],"a")) == NULL
     )
    {
      perror("fopen");
      exit(EXIT_FAILURE);
    }
  
  while( fgets(tampon,sizeof(tampon) -1,fic1) != NULL )
    fputs(tampon,fic2);

  fclose(fic1);fclose(fic2);
  exit(EXIT_SUCCESS);
}
