#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


void init_fibo(int in_fic,int out_fic,int niveau)
{
  int p=0,q=1;
  write(out_fic,&p,sizeof(int));
  write(out_fic,&q,sizeof(int));
  write(out_fic,&niveau,sizeof(int));
}

void iter_fibo(int in_fic,int out_fic)
{
  int p,q,somme;
  int niveau,temp_niveau;

  do{
    read(in_fic,&p,sizeof(int));
    read(in_fic,&q,sizeof(int));
    somme = p+q;
    /*  Le programme peut sortir ici,  */
    /*  si le tube n'est pas ouverte en lecture par personne */
    if(read(in_fic,&niveau,sizeof(int)) == 0)
      exit(EXIT_SUCCESS);
    
    if(niveau == 0)
      {
	/*  Ou ici,  */
	/*  si on a termin ls calculs */
	printf("%d\n",p);
	exit(EXIT_SUCCESS);
      }
    write(out_fic,&q,sizeof(int));
    write(out_fic,&somme,sizeof(int));
    temp_niveau = niveau-1;
    write(out_fic,&temp_niveau,sizeof(int));
  }while(1);
  
}

int main(int argc, char *argv[])
{
  int pf[2],fp[2];
  int niveau;
  
  if(! (argc == 2 && sscanf(argv[1],"%d",&niveau)) == 1 )
    {
      printf("%s : arguments invalides\n",argv[0]);
      exit(EXIT_FAILURE);
    }

  pipe(pf);pipe(fp);
  
  if(fork())
    {
      close(pf[0]);close(fp[1]);
      init_fibo(fp[0],pf[1],niveau);
      iter_fibo(fp[0],pf[1]);
    }
  else
    {
      close(pf[1]);close(fp[0]);
      iter_fibo(pf[0],fp[1]);
    }


}

