#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(void)
{
  int tube[2];

  pipe(tube);

  if(fork())
    {
      close(tube[1]);
      close(STDIN_FILENO);
      dup(tube[0]);
      close(tube[0]);
      
      execlp("grep","grep","-c","\\.[ch]$",NULL);    
      perror("grep");
    }
  else
    {
      close(tube[0]);
      close(STDOUT_FILENO);
      dup(tube[1]);
      close(tube[1]);
      
      execlp("ls","ls",NULL);
      perror("ls");
    }
  
  exit(EXIT_FAILURE);
}
