#include "monsleepwakeup.h"

#include <unistd.h>
#include <signal.h>
#include <stdio.h>

static sigset_t old, new;
static struct sigaction action;
 
void wakeup_handler(int sig){
  return ;
}

void mon_sleep(void)
{
  printf("[%d] Je m'endort.\n",getpid());
  /* Essayer ce qu'il arrive si l'on substitue la ligne suivante */
  /* avec la ligne */
  /* pause() ; */
  sigsuspend(&old);
  printf("[%d] Je me reveille.\n",getpid());
  return;
}

void mon_wakeup(int pid)
{
  kill(pid,SIGUSR1);
}

void init_sleepwakeup(void)
{
  sigprocmask(SIG_SETMASK,NULL,&old);
  if(sigismember(&old,SIGUSR1))
    sigdelset(&old,SIGUSR1);
  sigprocmask(SIG_SETMASK,NULL,&new);
  sigaddset(&new,SIGUSR1);
  sigprocmask(SIG_SETMASK,&new,NULL);
  action.sa_flags=0;
  action.sa_handler=wakeup_handler;
  sigemptyset(&action.sa_mask);
  sigaction(SIGUSR1,&action,NULL);
}
