(* 
   Calcul du nieme nombre premier 
   Auteur : Luigi Santocanale
   Exercice 9 du TD 2 

   Remarques :

   # List.exists;;
   - : ('a -> bool) -> 'a list -> bool = <fun>
   # List.hd;;
   - : 'a list -> 'a = <fun>

   definis dans le module List, que l'on peu "browser"
   avec ocamlbrowser
*)

let rec tantque predicat changer x0 =
  if not (predicat x0)  then 
    x0
  else
    tantque predicat changer (changer x0);;

let rec liste_nb_premiers = function 
    0 -> []
  | 1 -> [2]
  | 2 -> [3;2]
  | n -> 
      let 
	divisible liste x =
	List.exists (fun y -> x mod y = 0) liste 
      and
	incr x = x + 2
      and
      	rec_liste = liste_nb_premiers (n-1)
      in
      let 
	start = List.hd rec_liste + 2
      in
     	(tantque (divisible rec_liste) incr start)::rec_liste;; 
	    
  
let nb_premier n = List.hd (liste_nb_premiers n);;

nb_premier 10000;;
