#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>

static void handler(int);
static void terminer(int);

static struct sigaction action;
static sigset_t ens;

int main()
{
  action.sa_handler = handler;
  action.sa_flags = 0;
  sigemptyset(&action.sa_mask);
  sigaction(SIGTSTP,&action,NULL);

  sigaddset(&action.sa_mask,SIGTSTP);
  sigaction(SIGINT,&action,NULL);
  
  while(1) sleep(1);
  return 0;
}

void handler(int signum)
{
  int i;
  
  printf("Reu signal : %d\n",signum);
  sigprocmask(SIG_BLOCK,NULL,&ens);
  printf("Signaux bloqus : ");
  
  for(i = 1; i < NSIG; i++)
    if(sigismember(&ens,i))
      printf("%d ",i);
  putchar('\n');
  
  if( signum == SIGINT ){
    action.sa_handler=terminer;
    sigaction(SIGTSTP,&action,NULL);
    printf("Essay maintenant avec CTRL-Z\n");
  }
 
  /* Longue tache ... */
  for(i=INT_MAX;i;i--);
  
  printf("Sortie du handler\n");
}

void terminer(int signum)
{
  printf("Sortie du programme\n");
  exit(EXIT_SUCCESS);
}
