#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

int x = 0;

void interruption(int signum)
{
   switch(signum)
    {
    case SIGINT:
      printf("\nCTRL-C\n");
      x++;
      break;
    case SIGQUIT:
      printf("\nCTRL-\\\n");
      x--;
      break;
    default:
      printf("\nAutre signal\n");
      if(!x)
	signal(SIGINT,SIG_DFL);
    }
   printf("(x est maintenant gal  %d)\n", x); 
}

int main(void)
{
  struct sigaction action;

  action.sa_handler=interruption;
  action.sa_flags=0;
  sigemptyset(&action.sa_mask);
  sigaction(SIGINT,&action,NULL);   /*  Recuperation de CRTL-C */
  sigaction(SIGQUIT,&action,NULL);  /*  Recuperation de CRTL-\ */
  sigaction(SIGTSTP,&action,NULL);  /*  Recuperation de CRTL-Z */ 
  
  for(;;)
    {
      printf("-");fflush(stdout);
      sleep(1);
    }
  return EXIT_SUCCESS;
}
