/* Exercice no 7 */
 
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>

void fork_recursif(int profondeur,int t[])
{
  int i,status;

  for(i=0;i<profondeur;i++)
    putchar('\t');
  printf("%d\t%d\n",getppid(),getpid());
  fflush(stdout);

  for(i=0; i <t[0];i++)
    {
      switch(fork())
	{
	case -1:
	  perror("fork");
	  exit(EXIT_FAILURE);
	case 0:
	  fork_recursif(profondeur + 1,&t[1]);
	default:
	  break;
	}
    }

  /* On attend la terminaison des fils 
     (pas obligatoire) */
  for(i=0; i <t[0];i++)
    wait(&status);

  exit(EXIT_SUCCESS);
}

int main(void)
{
  /* Il faut terminer le tableau par 0 */
  int t[] = {2,3,4,3,0};

  fork_recursif(0,t);  

  /*Ici on ne revient pas */
  return EXIT_SUCCESS;
}

