#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

void parent(int entree, int sortie)
{
	unsigned char n;
	n=0;
	write(sortie, &n, 1);
	n=1;
	write(sortie, &n, 1);
	do
	{
		read(entree, &n, 1);
		printf("%u ", n);
		write(sortie, &n, 1);
	} while (n <= 200);
	exit(EXIT_SUCCESS);
}

void enfant(int entree, int sortie)
{
	unsigned char p,q;
	read(entree, &p, 1);
	for (;;)
	{
		write(sortie, &p, 1);
		if (read(entree, &q, 1) != 1) exit(EXIT_SUCCESS);
		p += q;
	}
}

int main(void)
{
	int tube_pe[2];
	int tube_ep[2];
	int pid;

	printf("[%d] dbut du pre.\n",getpid());

	pipe(tube_pe); /* tube Parent -> Enfant */
	pipe(tube_ep); /* tube Enfant -> Parent */


    if ( (pid = fork()) == -1) exit(EXIT_FAILURE);
    if (pid > 0) /* parent */
	{
		close(tube_pe[0]);
		close(tube_ep[1]);
		parent(tube_ep[0], tube_pe[1]);
	}
    else /* enfant */
	{
		close(tube_pe[1]);
		close(tube_ep[0]);
		enfant(tube_pe[0], tube_ep[1]);
	}
    printf("[%d] : terminaison\n", getpid());
    exit(EXIT_SUCCESS);
}
