#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define SORTIETUBE 0
#define ENTRETUBE 1 

int rediriger(int i, int tube[2]);

int main(int argc, char *argv[])
{
  int tube1[2];
  int tube2[2];
  
  pipe(tube2);
  if( fork() ) /* pre */  
    {
      rediriger(STDIN_FILENO,tube2); 
      execlp("wc","wc","-l",NULL);
      /* Jaimais atteint sauf erreur */
      perror("Erreur dans exec wc");
    }
  else 
    {
      rediriger(STDOUT_FILENO,tube2);
      pipe(tube1);
      if( fork() ) /* fils */
	{
	  rediriger(STDIN_FILENO,tube1);
	  execlp("grep","grep",".c$",NULL);
	  /* Jaimais atteint sauf erreur */
	  perror("Erreur dans exec grep ");
	}
      else /* grand fils */
	{
	  rediriger(STDOUT_FILENO,tube1);
  	  execlp("ls","ls","-l",NULL);
	  /* Jaimais atteint sauf erreur */
	  perror("Erreur dans exec ls");
	}
    }
  /* Jaimais atteint sauf erreur */
  exit(EXIT_FAILURE);
}

int rediriger(int i,int tube[2])
{
  switch(i)
    {
    case STDIN_FILENO:
      dup2(tube[SORTIETUBE],STDIN_FILENO);
      close(tube[SORTIETUBE]);
      close(tube[ENTRETUBE]);
      return EXIT_SUCCESS;
      break;
      
    case STDOUT_FILENO:
      dup2(tube[ENTRETUBE],STDOUT_FILENO);
      close(tube[SORTIETUBE]);
      close(tube[ENTRETUBE]);
      return EXIT_SUCCESS;
      break;
    }
  return EXIT_FAILURE;
}
