#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>

int mon_execvp(char *command,char *argv[]);
int essayer(char * chemin,char *argv[]);

int main(int argc, char *argv[])
{
  if(argc <= 1)
    exit(EXIT_FAILURE);
  
  mon_execvp(argv[1],&argv[1]);
  /* Execut seulement en cas d'erreur */
  perror("mon_execvp");
  exit(EXIT_FAILURE);
}

int mon_execvp(char *commande,char *argv[]){
  
  char chemincomplet[256];
  char *path=getenv("PATH");
  char *end=path;
  char *begin=path;
  
  assert( path != NULL);
  /* La recherche suivante peut tre perfectionne L.S. */
  while(*end != '\0')
    {
      while(*end != ':' && *end != '\0')
	end++;
      
      if(*end == ':')
	{
	  strncpy(chemincomplet,begin,end-begin);
	  if( chemincomplet[end-begin - 1] != '/')
	    {
	      chemincomplet[end-begin] = '/';
	      chemincomplet[end-begin + 1] = 0;
	    }
	  else
	    chemincomplet[end-begin] = 0;
	  
	  strcat(chemincomplet,argv[0]);  
	  essayer(chemincomplet,argv);  
	  end++;
	  begin=end;
	}      
    }
  exit(EXIT_SUCCESS);
}

int essayer(char *chemin,char *argv[]){
  if(access(chemin,F_OK) == -1)
    return -1;
  
  if(access(chemin,X_OK) == -1)
    {
      perror("Pas des permissions");
      exit(EXIT_FAILURE);
    }
  execv(chemin,argv);
  exit(EXIT_FAILURE);
}
